import re
from pathlib import Path

from numpy import datetime64


def extract_run_date_from_filename(
    path: str | Path, pattern: str = r"[\d]{4}-[\d]{2}-[\d]{2}"
) -> datetime64:
    if isinstance(path, Path):
        path = str(path.absolute())

    try:
        run_date = re.search(pattern, path).group()
        return run_date
    except AttributeError:
        raise ValueError(
            "No acquisition date was passed or could be inferred from the dataset path. Is the date formatted as YYYY-MM-DD?"
        )
